// Copyright: This source code is copyrighted (c) 2006 by Johan Erasmus. All rights reserved. This source code shall remain the exclusive
//            property of the author(s).
//
// Distribution: You are granted a non-exlusive, royalty-free right to produce and distribute compiled binary files that are built with any
//               of this source code unless specifically stated otherwise.
//               Without the express written consent of the author, you may not:
//               - Distribute modified versions of any source code by itself. You must include the original source code as you found it at
//                 the author(s)' web site.
//               - Sell or lease any portion of this source code. You are free to sell any of your own original code that works with or
//                 enhances this source code.
//               - Distribute this source code for profit.
//
// Disclaimer: This source code is provided 'as is' with no warranty of any kind.
//             The author disclaims all warranties, expressed or implied, including, without limitation, the warranties of merchantability
//             and of fitness for any purpose. Johan Erasmus assumes no liability for damages, direct or consequential, which may result
//             from the use of this source code. You also agree to not hold Johan Erasmus liable for any damages, direct or consequential
//             which may result from the use of this source code. By using this source code, you are agreeing to all of these conditions.
//
// Support: You are free to contact me, but I can not gaurantee any support whatsoever. I will however try to answer all question that are
//          directed to me.
//
// Contact Information: jerasmus@flashmail.com
//
//
// Date convention: dd/mm/yyyy
// Date Started: 21/05/2002
// Date Completed: 03/09/2002
// Date Modified: 06/09/2002 - Added two new constants for initial icon size
//                02/01/2003 - Added new exception and lowered minimum width & height to 2
//
// Version: 3.00
// Compiler: Borland Delphi 5 Profesional (UP 1)
// Delphi Support: 4, 5, 6 (Tested only on 5)
// OS Platforms Supported: Win 9x, Win ME, Win NT 4, Win 2k, Win XP (ps32Bit only on XP)
// OS Platforms Tested: Win XP (SP 2)
//
// Description: Include file with constants for Icon.PAS
// Developed by: Johan Erasmus
//



Const
  cHeaderReserved = 0;                                     //Reserved byte in the icon file header
  cIcon   = 1;                                             //1 in the header indicates icon file
  cCursor = 2;                                             //2 in the header indicates cursor file 

  cMaxIconsInFile = 64;                                    //The maximum icons in an icon file

  cDefaultIconWidth  = 32;                                 //The default icon width
  cDefaultIconHeight = cDefaultIconWidth;                  //The default icon height = default width

  //The Min & Max Height and Width of an icon
  cMinIconWidth = 2;
  cMaxIconWidth = 96;
  cMinIconHeight = cMinIconWidth;
  cMaxIconHeight = cMaxIconWidth;



  //The resource names of the color tables
  cPaletteRes1Bit     = 'ICOCOLORTABLE2';
  cPaletteRes4Bit     = 'ICOCOLORTABLE16';
  cPaletteRes8Bit     = 'ICOCOLORTABLE256';
  cPaletteRes8BitGray = 'ICOCOLORTABLE256GRAY';            //True 8 bit gray palette without reserved windows colours

  //Palette
  cPaletteSize  = ps8Bit;                                  //The initial palette

  //IconImage error messages
  ceEmptyFile           = 'In order to save an icon file, there must at least be one icon in the list.';
  ceInvalidSize         = 'Invalid size specified in width or height: (Width = %d, Height = %d)';
  ceInvalidBPP          = 'Invalid color depth in bitmap header: (BPP = %d)';
  ceInvalidColorCount   = 'Invalid color depth in icon header: (Colors = %d)';
  ceInvalidPaletteRange = 'Palette index out of range: (Index = %d)';
  ceInvalidOwner        = 'Invalid owner: (%s), owner must be TIconList';
  ceInvalidICOHeader    = 'Not a valid icon file header.';
  ceCorruptFile         = 'Can not load icon from file: The file could be corrupt.';
  ceInvalidAlphaBits    = 'Invalid transparent pixels: (X = %d, Y = %d)';
  ceNoAlphaBits         = 'Icon has no transparent pixels.';
  ceCopyFailed          = 'Can not copy icon.';

  //TIconList errors messages
  ceMainLoadError       = 'Some icons could not be loaded due to the following errors: ';
  ceListIndexError      = 'Icon list index out of bounds: (%d)';
  ceNoNullEntry         = 'Can not add Nil entries to icon list.';
  ceNotAnIcon           = 'Can not return a TIcon object for a cursor.';



